#ifndef BASRELIEF_H
#define BASRELIEF_H

#include <QtCore>

#include "algebra3.h"
#include "studydata.h"

class BasRelief
{

public:

    BasRelief();

    //analysis - generalized bas relief transform stuff
    void SetBasisVectors(const vec3 b_x, const vec3 b_y, const vec3 b_z);
    void SetBasisVectors(const float modelview[]);

    void ComputeBasReliefTransforms(QList <StudyData> & studydatas);
    void ComputeBasReliefTransforms(const QList <vec3> & ground_truth, const QList <vec3> & input, QList <vec3> & transformed);
    float ComputeBasReliefL1Norm(const QList <vec3> & guess_norms, const QList <vec3> & true_norms, const vec3 & lmn);

    static vec3 BasReliefTransformNormal(const vec3 & v, const vec3 & lmn);

private:

    vec3 basis_x;
    vec3 basis_y;
    vec3 basis_z;

};

#endif // BASRELIEF_H
