#ifndef SCATTERPLOT_H
#define SCATTERPLOT_H

#include <QtCore>

class Scatterplot
{

public:

    Scatterplot();

    void AddSample(const float x, const float y);
    void AddSample(const float x, const float y, const QString & l);

    void Clear();

    float GetMeanX() const;
    float GetMeanY() const;

    float GetVarianceX() const;
    float GetVarianceY() const;
    float GetCovarianceXY() const;

    void GetLinearModelParameters(float & a, float & b) const;
    float GetResidualSumOfSquares();
    float GetRSquared();

    void OutputData() const;
    void OutputLinearRegression();

private:

    void ComputeLinearModel();

    QList <float> sample_x;
    QList <float> sample_y;
    QList <QString> labels;

    float model_a;
    float model_b;
    bool model_recompute;


};

#endif // SCATTERPLOT_H
