#include "studydata.h"

QString StudyData::delimiter(" ");

void StudyData::Write(QTextStream & ofs) const {

    ofs << ToString();

}

void StudyData::Read(QTextStream & ifs) {

    QString line = ifs.readLine();
    FromString(line);

}

QString StudyData::ToString() const
{

    QString s;

    s += QString("Gauge") + delimiter;
    if (study_task == ROTATE) {
        s += QString("0") + delimiter;
    }
    else if (study_task == ROTATE_VIEW) {
        s += QString("1") + delimiter;
    }
    s += QString::number(abstraction) + delimiter;    
    s += QString::number(model_index) + delimiter;
    s += QString::number(sequence_num) + delimiter;
    s += QString::number(num_cam_manipulations) + delimiter;
    s += QString::number(num_gauge_manipulations) + delimiter;
    s += QString::number(trial_time_ms) + delimiter;
    s += QString::number(initial_normal[0]) + delimiter;
    s += QString::number(initial_normal[1]) + delimiter;
    s += QString::number(initial_normal[2]) + delimiter;
    s += QString::number(guessed_normal[0]) + delimiter;
    s += QString::number(guessed_normal[1]) + delimiter;
    s += QString::number(guessed_normal[2]);

    s += "\n";

    return s;

}

bool StudyData::FromString(const QString & s)
{

    QStringList tokens = s.split(delimiter);

    if (tokens.empty() || tokens.size() < 14) {
        return false;
    }

    if (QString::compare("Gauge", tokens[0]) != 0) {
        return false;
    }

    study_task = (QString::compare("0", tokens[1]) == 0) ? ROTATE : ROTATE_VIEW;
    abstraction = tokens[2].toInt();
    model_index = tokens[3].toInt();
    sequence_num = tokens[4].toInt();
    num_cam_manipulations = tokens[5].toInt();
    num_gauge_manipulations = tokens[6].toInt();
    trial_time_ms = tokens[7].toInt();
    initial_normal[0] = tokens[8].toFloat();
    initial_normal[1] = tokens[9].toFloat();
    initial_normal[2] = tokens[10].toFloat();
    guessed_normal[0] = tokens[11].toFloat();
    guessed_normal[1] = tokens[12].toFloat();
    guessed_normal[2] = tokens[13].toFloat();

    return true;

}
