#ifndef STUDYDATA_H
#define STUDYDATA_H

#include <QtCore>

#include "algebra3.h"

enum StudyTask {
    ROTATE,
    ROTATE_VIEW
};

struct StudyData
{

    //calculated
    StudyTask study_task;
    int abstraction;

    //guaranteed read    
    int model_index;
    int sequence_num;
    int num_cam_manipulations;
    int num_gauge_manipulations;
    int trial_time_ms;
    vec3 initial_normal;
    vec3 guessed_normal;

    //ground truth attributes
    int model_faceindex;
    vec2 screen_pos;
    vec3 pos;
    vec3 true_normal;

    //calculated    
    vec3 bas_corrected_normal;
    float task_error; //angle in degrees (difference between true and guessed normal)

    //found in turk data
    QString worker_id;

    //things we measure at each point
    bool flatness;

    float curv1; //beta_1
    float curv2;
    float curv_gaussian;
    float curv_mean;

    float med_axis_dist; //beta_2

    float local_thickness; //beta_3

    float centroid_distance; //beta_4

    float viewnorm_angle; //beta_5

    float abstraction_distance;

    float abstraction_angle_difference;   

    //utility methods
    void Write(QTextStream & ofs) const;
    void Read(QTextStream & ifs);

    QString ToString() const;
    bool FromString(const QString & s);

    static QString delimiter;

};

#endif // STUDYDATA_H
