#ifndef TNBFRAME_H
#define TNBFRAME_H

#include "algebra3.h"

class TNBFrame
{

public:

    TNBFrame();

    vec3 N() const;
    vec3 T() const;
    vec3 B() const;

    void SetN(const vec3 & v);
    void SetT(const vec3 & v);
    void SetB(const vec3 & v);

    void SetTNB(const vec3 & vt, const vec3 & vn, const vec3 & vb);

    void RotateFrame(const vec3 & axis, const float angledeg);

protected:

    vec3 GetOrthoVec(const vec3 & v);

    vec3 t;
    vec3 n;
    vec3 b;

};

#endif // TNBFRAME_H
